#include "StdAfx.h"
#include "Filter.h"
#include "Form1.h"

using namespace System;

Filter::Filter(void)
{
}

//-------------------------------------------------------------------------------------------
//y֐@zFFilter::Segmentation
//yTvzFl
//y@@zFpSourceBuf	= Ỏ摜̃|C^(In)
//            FpResultBuf	= ̉摜̃|C^(Out)
//            FWidth		= 摜̕(In)
//            FHeight		= 摜̍(In)
//            FBitCount	= 摜̃rbg(In)
//            FThreshold	= l(In)
//y߂l@zF0			= I
//            F-1			= G[iΉ摜f[^j
//yl@@zF
//-------------------------------------------------------------------------------------------
int Filter::Segmentation(	
			unsigned char* pSourceBuf, unsigned char* pResultBuf,
			int Width, int Height, int BitCount, unsigned char Threshold)
{
	int i, j;
	int BufWidth;	//̕ioCgj
	int Bright;		//Pxl
	int R, G, B;	//R,G,B̋Pxl

	//̕ioCg(SoCgP)j
	BufWidth = ((Width * BitCount + 31) / 32) * 4;
	
	switch (BitCount){
		case 8:
			//Wrbg摜̏ꍇ
			for (j = 0; j < Height ; j++){
				for ( i = 0; i < Width; i++){
					//͉摜̋Pxl̎擾
					Bright = pSourceBuf[i + j * BufWidth];
					//l
					if (Bright >= Threshold)
						pResultBuf[i + j * BufWidth] = 255;
					else
						pResultBuf[i + j * BufWidth] =0;
				}
			}

			break;

		case 24:
			//QSrbg摜̏ꍇ
			for (j = 0; j < Height ; j++){
				for ( i = 0; i < Width * 3; i += 3){
					//͉摜̋Pxl̎擾(B,G,R,B,G,REEEȄ)
					B = pSourceBuf[i +     j * BufWidth];
					G = pSourceBuf[i + 1 + j * BufWidth];
					R = pSourceBuf[i + 2 + j * BufWidth];
					
					//l
					//B
					if (B >= Threshold)
						pResultBuf[i + j * BufWidth] = 255;
					else
						pResultBuf[i + j * BufWidth] = 0;

					//G
					if (G >= Threshold)
						pResultBuf[i + 1 + j * BufWidth] = 255;
					else
						pResultBuf[i + 1 + j * BufWidth] = 0;

					//R
					if (R >= Threshold)
						pResultBuf[i + 2 + j * BufWidth] = 255;
					else
						pResultBuf[i + 2 + j * BufWidth] = 0;

				}
			}
			break;

		default:
			//̑̃rbg̉摜͖Ή
			return -1;
	}
	//I
	return 0;
}